   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.8.32.1 - 30 Mar 2010
   3                     ; Generator V4.3.4 - 23 Mar 2010
  43                     ; 65 void ADC2_DeInit(void)
  43                     ; 66 {
  45                     	switch	.text
  46  0000               _ADC2_DeInit:
  50                     ; 67   ADC2->CSR  = ADC2_CSR_RESET_VALUE;
  52  0000 725f5400      	clr	21504
  53                     ; 68   ADC2->CR1  = ADC2_CR1_RESET_VALUE;
  55  0004 725f5401      	clr	21505
  56                     ; 69   ADC2->CR2  = ADC2_CR2_RESET_VALUE;
  58  0008 725f5402      	clr	21506
  59                     ; 70   ADC2->TDRH = ADC2_TDRH_RESET_VALUE;
  61  000c 725f5406      	clr	21510
  62                     ; 71   ADC2->TDRL = ADC2_TDRL_RESET_VALUE;
  64  0010 725f5407      	clr	21511
  65                     ; 72 }
  68  0014 81            	ret
 593                     ; 107 void ADC2_Init(ADC2_ConvMode_TypeDef ADC2_ConversionMode, ADC2_Channel_TypeDef ADC2_Channel, ADC2_PresSel_TypeDef ADC2_PrescalerSelection, ADC2_ExtTrig_TypeDef ADC2_ExtTrigger, FunctionalState ADC2_ExtTrigState, ADC2_Align_TypeDef ADC2_Align, ADC2_SchmittTrigg_TypeDef ADC2_SchmittTriggerChannel, FunctionalState ADC2_SchmittTriggerState)
 593                     ; 108 {
 594                     	switch	.text
 595  0015               _ADC2_Init:
 597  0015 89            	pushw	x
 598       00000000      OFST:	set	0
 601                     ; 111   assert_param(IS_ADC2_CONVERSIONMODE_OK(ADC2_ConversionMode));
 603                     ; 112   assert_param(IS_ADC2_CHANNEL_OK(ADC2_Channel));
 605                     ; 113   assert_param(IS_ADC2_PRESSEL_OK(ADC2_PrescalerSelection));
 607                     ; 114   assert_param(IS_ADC2_EXTTRIG_OK(ADC2_ExtTrigger));
 609                     ; 115   assert_param(IS_FUNCTIONALSTATE_OK(((ADC2_ExtTrigState))));
 611                     ; 116   assert_param(IS_ADC2_ALIGN_OK(ADC2_Align));
 613                     ; 117   assert_param(IS_ADC2_SCHMITTTRIG_OK(ADC2_SchmittTriggerChannel));
 615                     ; 118   assert_param(IS_FUNCTIONALSTATE_OK(ADC2_SchmittTriggerState));
 617                     ; 123   ADC2_ConversionConfig(ADC2_ConversionMode, ADC2_Channel, ADC2_Align);
 619  0016 7b08          	ld	a,(OFST+8,sp)
 620  0018 88            	push	a
 621  0019 9f            	ld	a,xl
 622  001a 97            	ld	xl,a
 623  001b 7b02          	ld	a,(OFST+2,sp)
 624  001d 95            	ld	xh,a
 625  001e cd00fa        	call	_ADC2_ConversionConfig
 627  0021 84            	pop	a
 628                     ; 125   ADC2_PrescalerConfig(ADC2_PrescalerSelection);
 630  0022 7b05          	ld	a,(OFST+5,sp)
 631  0024 ad33          	call	_ADC2_PrescalerConfig
 633                     ; 130   ADC2_ExternalTriggerConfig(ADC2_ExtTrigger, ADC2_ExtTrigState);
 635  0026 7b07          	ld	a,(OFST+7,sp)
 636  0028 97            	ld	xl,a
 637  0029 7b06          	ld	a,(OFST+6,sp)
 638  002b 95            	ld	xh,a
 639  002c cd0128        	call	_ADC2_ExternalTriggerConfig
 641                     ; 135   ADC2_SchmittTriggerConfig(ADC2_SchmittTriggerChannel, ADC2_SchmittTriggerState);
 643  002f 7b0a          	ld	a,(OFST+10,sp)
 644  0031 97            	ld	xl,a
 645  0032 7b09          	ld	a,(OFST+9,sp)
 646  0034 95            	ld	xh,a
 647  0035 ad35          	call	_ADC2_SchmittTriggerConfig
 649                     ; 138   ADC2->CR1 |= ADC2_CR1_ADON;
 651  0037 72105401      	bset	21505,#0
 652                     ; 140 }
 655  003b 85            	popw	x
 656  003c 81            	ret
 691                     ; 157 void ADC2_Cmd(FunctionalState NewState)
 691                     ; 158 {
 692                     	switch	.text
 693  003d               _ADC2_Cmd:
 697                     ; 161   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 699                     ; 163   if (NewState != DISABLE)
 701  003d 4d            	tnz	a
 702  003e 2706          	jreq	L703
 703                     ; 165     ADC2->CR1 |= ADC2_CR1_ADON;
 705  0040 72105401      	bset	21505,#0
 707  0044 2004          	jra	L113
 708  0046               L703:
 709                     ; 169     ADC2->CR1 &= (u8)(~ADC2_CR1_ADON);
 711  0046 72115401      	bres	21505,#0
 712  004a               L113:
 713                     ; 172 }
 716  004a 81            	ret
 751                     ; 192 void ADC2_ITConfig(FunctionalState ADC2_ITEnable)
 751                     ; 193 {
 752                     	switch	.text
 753  004b               _ADC2_ITConfig:
 757                     ; 196   assert_param(IS_FUNCTIONALSTATE_OK(ADC2_ITEnable));
 759                     ; 198   if (ADC2_ITEnable != DISABLE)
 761  004b 4d            	tnz	a
 762  004c 2706          	jreq	L133
 763                     ; 201     ADC2->CSR |= (u8)ADC2_CSR_EOCIE;
 765  004e 721a5400      	bset	21504,#5
 767  0052 2004          	jra	L333
 768  0054               L133:
 769                     ; 206     ADC2->CSR &= (u8)(~ADC2_CSR_EOCIE);
 771  0054 721b5400      	bres	21504,#5
 772  0058               L333:
 773                     ; 209 }
 776  0058 81            	ret
 812                     ; 226 void ADC2_PrescalerConfig(ADC2_PresSel_TypeDef ADC2_Prescaler)
 812                     ; 227 {
 813                     	switch	.text
 814  0059               _ADC2_PrescalerConfig:
 816  0059 88            	push	a
 817       00000000      OFST:	set	0
 820                     ; 230   assert_param(IS_ADC2_PRESSEL_OK(ADC2_Prescaler));
 822                     ; 233   ADC2->CR1 &= (u8)(~ADC2_CR1_SPSEL);
 824  005a c65401        	ld	a,21505
 825  005d a48f          	and	a,#143
 826  005f c75401        	ld	21505,a
 827                     ; 235   ADC2->CR1 |= (u8)(ADC2_Prescaler);
 829  0062 c65401        	ld	a,21505
 830  0065 1a01          	or	a,(OFST+1,sp)
 831  0067 c75401        	ld	21505,a
 832                     ; 237 }
 835  006a 84            	pop	a
 836  006b 81            	ret
 884                     ; 257 void ADC2_SchmittTriggerConfig(ADC2_SchmittTrigg_TypeDef ADC2_SchmittTriggerChannel, FunctionalState ADC2_SchmittTriggerState)
 884                     ; 258 {
 885                     	switch	.text
 886  006c               _ADC2_SchmittTriggerConfig:
 888  006c 89            	pushw	x
 889       00000000      OFST:	set	0
 892                     ; 261   assert_param(IS_ADC2_SCHMITTTRIG_OK(ADC2_SchmittTriggerChannel));
 894                     ; 262   assert_param(IS_FUNCTIONALSTATE_OK(ADC2_SchmittTriggerState));
 896                     ; 264   if (ADC2_SchmittTriggerChannel == ADC2_SCHMITTTRIG_ALL)
 898  006d 9e            	ld	a,xh
 899  006e a11f          	cp	a,#31
 900  0070 2620          	jrne	L573
 901                     ; 266     if (ADC2_SchmittTriggerState != DISABLE)
 903  0072 9f            	ld	a,xl
 904  0073 4d            	tnz	a
 905  0074 270a          	jreq	L773
 906                     ; 268       ADC2->TDRL &= (u8)0x0;
 908  0076 725f5407      	clr	21511
 909                     ; 269       ADC2->TDRH &= (u8)0x0;
 911  007a 725f5406      	clr	21510
 913  007e 2078          	jra	L304
 914  0080               L773:
 915                     ; 273       ADC2->TDRL |= (u8)0xFF;
 917  0080 c65407        	ld	a,21511
 918  0083 aaff          	or	a,#255
 919  0085 c75407        	ld	21511,a
 920                     ; 274       ADC2->TDRH |= (u8)0xFF;
 922  0088 c65406        	ld	a,21510
 923  008b aaff          	or	a,#255
 924  008d c75406        	ld	21510,a
 925  0090 2066          	jra	L304
 926  0092               L573:
 927                     ; 277   else if (ADC2_SchmittTriggerChannel < ADC2_SCHMITTTRIG_CHANNEL8)
 929  0092 7b01          	ld	a,(OFST+1,sp)
 930  0094 a108          	cp	a,#8
 931  0096 242f          	jruge	L504
 932                     ; 279     if (ADC2_SchmittTriggerState != DISABLE)
 934  0098 0d02          	tnz	(OFST+2,sp)
 935  009a 2716          	jreq	L704
 936                     ; 281       ADC2->TDRL &= (u8)(~(u8)((u8)0x01 << (u8)ADC2_SchmittTriggerChannel));
 938  009c 7b01          	ld	a,(OFST+1,sp)
 939  009e 5f            	clrw	x
 940  009f 97            	ld	xl,a
 941  00a0 a601          	ld	a,#1
 942  00a2 5d            	tnzw	x
 943  00a3 2704          	jreq	L02
 944  00a5               L22:
 945  00a5 48            	sll	a
 946  00a6 5a            	decw	x
 947  00a7 26fc          	jrne	L22
 948  00a9               L02:
 949  00a9 43            	cpl	a
 950  00aa c45407        	and	a,21511
 951  00ad c75407        	ld	21511,a
 953  00b0 2046          	jra	L304
 954  00b2               L704:
 955                     ; 285       ADC2->TDRL |= (u8)((u8)0x01 << (u8)ADC2_SchmittTriggerChannel);
 957  00b2 7b01          	ld	a,(OFST+1,sp)
 958  00b4 5f            	clrw	x
 959  00b5 97            	ld	xl,a
 960  00b6 a601          	ld	a,#1
 961  00b8 5d            	tnzw	x
 962  00b9 2704          	jreq	L42
 963  00bb               L62:
 964  00bb 48            	sll	a
 965  00bc 5a            	decw	x
 966  00bd 26fc          	jrne	L62
 967  00bf               L42:
 968  00bf ca5407        	or	a,21511
 969  00c2 c75407        	ld	21511,a
 970  00c5 2031          	jra	L304
 971  00c7               L504:
 972                     ; 290     if (ADC2_SchmittTriggerState != DISABLE)
 974  00c7 0d02          	tnz	(OFST+2,sp)
 975  00c9 2718          	jreq	L514
 976                     ; 292       ADC2->TDRH &= (u8)(~(u8)((u8)0x01 << ((u8)ADC2_SchmittTriggerChannel - (u8)8)));
 978  00cb 7b01          	ld	a,(OFST+1,sp)
 979  00cd a008          	sub	a,#8
 980  00cf 5f            	clrw	x
 981  00d0 97            	ld	xl,a
 982  00d1 a601          	ld	a,#1
 983  00d3 5d            	tnzw	x
 984  00d4 2704          	jreq	L03
 985  00d6               L23:
 986  00d6 48            	sll	a
 987  00d7 5a            	decw	x
 988  00d8 26fc          	jrne	L23
 989  00da               L03:
 990  00da 43            	cpl	a
 991  00db c45406        	and	a,21510
 992  00de c75406        	ld	21510,a
 994  00e1 2015          	jra	L304
 995  00e3               L514:
 996                     ; 296       ADC2->TDRH |= (u8)((u8)0x01 << ((u8)ADC2_SchmittTriggerChannel - (u8)8));
 998  00e3 7b01          	ld	a,(OFST+1,sp)
 999  00e5 a008          	sub	a,#8
1000  00e7 5f            	clrw	x
1001  00e8 97            	ld	xl,a
1002  00e9 a601          	ld	a,#1
1003  00eb 5d            	tnzw	x
1004  00ec 2704          	jreq	L43
1005  00ee               L63:
1006  00ee 48            	sll	a
1007  00ef 5a            	decw	x
1008  00f0 26fc          	jrne	L63
1009  00f2               L43:
1010  00f2 ca5406        	or	a,21510
1011  00f5 c75406        	ld	21510,a
1012  00f8               L304:
1013                     ; 300 }
1016  00f8 85            	popw	x
1017  00f9 81            	ret
1074                     ; 322 void ADC2_ConversionConfig(ADC2_ConvMode_TypeDef ADC2_ConversionMode, ADC2_Channel_TypeDef ADC2_Channel, ADC2_Align_TypeDef ADC2_Align)
1074                     ; 323 {
1075                     	switch	.text
1076  00fa               _ADC2_ConversionConfig:
1078  00fa 89            	pushw	x
1079       00000000      OFST:	set	0
1082                     ; 326   assert_param(IS_ADC2_CONVERSIONMODE_OK(ADC2_ConversionMode));
1084                     ; 327   assert_param(IS_ADC2_CHANNEL_OK(ADC2_Channel));
1086                     ; 328   assert_param(IS_ADC2_ALIGN_OK(ADC2_Align));
1088                     ; 331   ADC2->CR2 &= (u8)(~ADC2_CR2_ALIGN);
1090  00fb 72175402      	bres	21506,#3
1091                     ; 333   ADC2->CR2 |= (u8)(ADC2_Align);
1093  00ff c65402        	ld	a,21506
1094  0102 1a05          	or	a,(OFST+5,sp)
1095  0104 c75402        	ld	21506,a
1096                     ; 335   if (ADC2_ConversionMode == ADC2_CONVERSIONMODE_CONTINUOUS)
1098  0107 9e            	ld	a,xh
1099  0108 a101          	cp	a,#1
1100  010a 2606          	jrne	L744
1101                     ; 338     ADC2->CR1 |= ADC2_CR1_CONT;
1103  010c 72125401      	bset	21505,#1
1105  0110 2004          	jra	L154
1106  0112               L744:
1107                     ; 343     ADC2->CR1 &= (u8)(~ADC2_CR1_CONT);
1109  0112 72135401      	bres	21505,#1
1110  0116               L154:
1111                     ; 347   ADC2->CSR &= (u8)(~ADC2_CSR_CH);
1113  0116 c65400        	ld	a,21504
1114  0119 a4f0          	and	a,#240
1115  011b c75400        	ld	21504,a
1116                     ; 349   ADC2->CSR |= (u8)(ADC2_Channel);
1118  011e c65400        	ld	a,21504
1119  0121 1a02          	or	a,(OFST+2,sp)
1120  0123 c75400        	ld	21504,a
1121                     ; 351 }
1124  0126 85            	popw	x
1125  0127 81            	ret
1171                     ; 373 void ADC2_ExternalTriggerConfig(ADC2_ExtTrig_TypeDef ADC2_ExtTrigger, FunctionalState ADC2_ExtTrigState)
1171                     ; 374 {
1172                     	switch	.text
1173  0128               _ADC2_ExternalTriggerConfig:
1175  0128 89            	pushw	x
1176       00000000      OFST:	set	0
1179                     ; 377   assert_param(IS_ADC2_EXTTRIG_OK(ADC2_ExtTrigger));
1181                     ; 378   assert_param(IS_FUNCTIONALSTATE_OK(ADC2_ExtTrigState));
1183                     ; 381   ADC2->CR2 &= (u8)(~ADC2_CR2_EXTSEL);
1185  0129 c65402        	ld	a,21506
1186  012c a4cf          	and	a,#207
1187  012e c75402        	ld	21506,a
1188                     ; 383   if (ADC2_ExtTrigState != DISABLE)
1190  0131 9f            	ld	a,xl
1191  0132 4d            	tnz	a
1192  0133 2706          	jreq	L574
1193                     ; 386     ADC2->CR2 |= (u8)(ADC2_CR2_EXTTRIG);
1195  0135 721c5402      	bset	21506,#6
1197  0139 2004          	jra	L774
1198  013b               L574:
1199                     ; 391     ADC2->CR2 &= (u8)(~ADC2_CR2_EXTTRIG);
1201  013b 721d5402      	bres	21506,#6
1202  013f               L774:
1203                     ; 395   ADC2->CR2 |= (u8)(ADC2_ExtTrigger);
1205  013f c65402        	ld	a,21506
1206  0142 1a01          	or	a,(OFST+1,sp)
1207  0144 c75402        	ld	21506,a
1208                     ; 397 }
1211  0147 85            	popw	x
1212  0148 81            	ret
1236                     ; 417 void ADC2_StartConversion(void)
1236                     ; 418 {
1237                     	switch	.text
1238  0149               _ADC2_StartConversion:
1242                     ; 419   ADC2->CR1 |= ADC2_CR1_ADON;
1244  0149 72105401      	bset	21505,#0
1245                     ; 420 }
1248  014d 81            	ret
1288                     ; 438 u16 ADC2_GetConversionValue(void)
1288                     ; 439 {
1289                     	switch	.text
1290  014e               _ADC2_GetConversionValue:
1292  014e 5205          	subw	sp,#5
1293       00000005      OFST:	set	5
1296                     ; 441   u16 temph = 0;
1298                     ; 442   u8 templ = 0;
1300                     ; 444   if (ADC2->CR2 & ADC2_CR2_ALIGN) /* Right alignment */
1302  0150 c65402        	ld	a,21506
1303  0153 a508          	bcp	a,#8
1304  0155 2715          	jreq	L725
1305                     ; 447     templ = ADC2->DRL;
1307  0157 c65405        	ld	a,21509
1308  015a 6b03          	ld	(OFST-2,sp),a
1309                     ; 449     temph = ADC2->DRH;
1311  015c c65404        	ld	a,21508
1312  015f 5f            	clrw	x
1313  0160 97            	ld	xl,a
1314  0161 1f04          	ldw	(OFST-1,sp),x
1315                     ; 451     temph = (u16)(templ | (u16)(temph << (u8)8));
1317  0163 1e04          	ldw	x,(OFST-1,sp)
1318  0165 7b03          	ld	a,(OFST-2,sp)
1319  0167 02            	rlwa	x,a
1320  0168 1f04          	ldw	(OFST-1,sp),x
1322  016a 2021          	jra	L135
1323  016c               L725:
1324                     ; 456     temph = ADC2->DRH;
1326  016c c65404        	ld	a,21508
1327  016f 5f            	clrw	x
1328  0170 97            	ld	xl,a
1329  0171 1f04          	ldw	(OFST-1,sp),x
1330                     ; 458     templ = ADC2->DRL;
1332  0173 c65405        	ld	a,21509
1333  0176 6b03          	ld	(OFST-2,sp),a
1334                     ; 460     temph = (u16)((u16)(templ << (u8)6) | (u16)(temph << (u8)8));
1336  0178 1e04          	ldw	x,(OFST-1,sp)
1337  017a 4f            	clr	a
1338  017b 02            	rlwa	x,a
1339  017c 1f01          	ldw	(OFST-4,sp),x
1340  017e 7b03          	ld	a,(OFST-2,sp)
1341  0180 97            	ld	xl,a
1342  0181 a640          	ld	a,#64
1343  0183 42            	mul	x,a
1344  0184 01            	rrwa	x,a
1345  0185 1a02          	or	a,(OFST-3,sp)
1346  0187 01            	rrwa	x,a
1347  0188 1a01          	or	a,(OFST-4,sp)
1348  018a 01            	rrwa	x,a
1349  018b 1f04          	ldw	(OFST-1,sp),x
1350  018d               L135:
1351                     ; 463   return ((u16)temph);
1353  018d 1e04          	ldw	x,(OFST-1,sp)
1356  018f 5b05          	addw	sp,#5
1357  0191 81            	ret
1401                     ; 483 FlagStatus ADC2_GetFlagStatus(void)
1401                     ; 484 {
1402                     	switch	.text
1403  0192               _ADC2_GetFlagStatus:
1407                     ; 486   return ((u8)(ADC2->CSR & ADC2_CSR_EOC));
1409  0192 c65400        	ld	a,21504
1410  0195 a480          	and	a,#128
1413  0197 81            	ret
1436                     ; 505 void ADC2_ClearFlag(void)
1436                     ; 506 {
1437                     	switch	.text
1438  0198               _ADC2_ClearFlag:
1442                     ; 507     ADC2->CSR &= (u8)(~ADC2_CSR_EOC);
1444  0198 721f5400      	bres	21504,#7
1445                     ; 508 }
1448  019c 81            	ret
1472                     ; 526 ITStatus ADC2_GetITStatus(void)
1472                     ; 527 {
1473                     	switch	.text
1474  019d               _ADC2_GetITStatus:
1478                     ; 528   return ((u8)(ADC2->CSR & ADC2_CSR_EOC));
1480  019d c65400        	ld	a,21504
1481  01a0 a480          	and	a,#128
1484  01a2 81            	ret
1508                     ; 546 void ADC2_ClearITPendingBit(void)
1508                     ; 547 {
1509                     	switch	.text
1510  01a3               _ADC2_ClearITPendingBit:
1514                     ; 548     ADC2->CSR &= (u8)(~ADC2_CSR_EOC);
1516  01a3 721f5400      	bres	21504,#7
1517                     ; 549 }
1520  01a7 81            	ret
1533                     	xdef	_ADC2_ClearITPendingBit
1534                     	xdef	_ADC2_GetITStatus
1535                     	xdef	_ADC2_ClearFlag
1536                     	xdef	_ADC2_GetFlagStatus
1537                     	xdef	_ADC2_GetConversionValue
1538                     	xdef	_ADC2_StartConversion
1539                     	xdef	_ADC2_ExternalTriggerConfig
1540                     	xdef	_ADC2_ConversionConfig
1541                     	xdef	_ADC2_SchmittTriggerConfig
1542                     	xdef	_ADC2_PrescalerConfig
1543                     	xdef	_ADC2_ITConfig
1544                     	xdef	_ADC2_Cmd
1545                     	xdef	_ADC2_Init
1546                     	xdef	_ADC2_DeInit
1565                     	end
