   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Generator V4.2.4 - 19 Dec 2007
   4                     .const:	section	.text
   5  0000               _HSIDivFactor:
   6  0000 01            	dc.b	1
   7  0001 02            	dc.b	2
   8  0002 04            	dc.b	4
   9  0003 08            	dc.b	8
  10  0004               _CLKPrescTable:
  11  0004 01            	dc.b	1
  12  0005 02            	dc.b	2
  13  0006 04            	dc.b	4
  14  0007 08            	dc.b	8
  15  0008 0a            	dc.b	10
  16  0009 10            	dc.b	16
  17  000a 14            	dc.b	20
  18  000b 28            	dc.b	40
  47                     ; 83 void CLK_DeInit(void)
  47                     ; 84 {
  49                     	switch	.text
  50  0000               _CLK_DeInit:
  54                     ; 86   CLK->ICKR = CLK_ICKR_RESET_VALUE;
  56  0000 350150c0      	mov	20672,#1
  57                     ; 87   CLK->ECKR = CLK_ECKR_RESET_VALUE;
  59  0004 725f50c1      	clr	20673
  60                     ; 88   CLK->SWR  = CLK_SWR_RESET_VALUE;
  62  0008 35e150c4      	mov	20676,#225
  63                     ; 89   CLK->SWCR = CLK_SWCR_RESET_VALUE;
  65  000c 725f50c5      	clr	20677
  66                     ; 90   CLK->CKDIVR = CLK_CKDIVR_RESET_VALUE;
  68  0010 351850c6      	mov	20678,#24
  69                     ; 91   CLK->PCKENR1 = CLK_PCKENR1_RESET_VALUE;
  71  0014 35ff50c7      	mov	20679,#255
  72                     ; 92   CLK->PCKENR2 = CLK_PCKENR2_RESET_VALUE;
  74  0018 35ff50ca      	mov	20682,#255
  75                     ; 93   CLK->CSSR = CLK_CSSR_RESET_VALUE;
  77  001c 725f50c8      	clr	20680
  78                     ; 95   CLK->CCOR = CLK_CCOR_RESET_VALUE;
  80  0020 725f50c9      	clr	20681
  82  0024               L52:
  83                     ; 96   while (CLK->CCOR & CLK_CCOR_CCOEN)
  85  0024 c650c9        	ld	a,20681
  86  0027 a501          	bcp	a,#1
  87  0029 26f9          	jrne	L52
  88                     ; 98   CLK->CCOR = CLK_CCOR_RESET_VALUE;
  90  002b 725f50c9      	clr	20681
  91                     ; 100   CLK->CANCCR = CLK_CANCCR_RESET_VALUE;
  93  002f 725f50cb      	clr	20683
  94                     ; 101   CLK->HSITRIMR = CLK_HSITRIMR_RESET_VALUE;
  96  0033 725f50cc      	clr	20684
  97                     ; 102   CLK->SWIMCCR = CLK_SWIMCCR_RESET_VALUE;
  99  0037 725f50cd      	clr	20685
 100                     ; 104 }
 103  003b 81            	ret
 159                     ; 123 void CLK_FastHaltWakeUpCmd(FunctionalState NewState)
 159                     ; 124 {
 160                     	switch	.text
 161  003c               _CLK_FastHaltWakeUpCmd:
 165                     ; 127   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 167                     ; 129   if (NewState != DISABLE)
 169  003c 4d            	tnz	a
 170  003d 2706          	jreq	L75
 171                     ; 132     CLK->ICKR |= CLK_ICKR_FHWU;
 173  003f 721450c0      	bset	20672,#2
 175  0043 2004          	jra	L16
 176  0045               L75:
 177                     ; 137     CLK->ICKR &= (u8)(~CLK_ICKR_FHWU);
 179  0045 721550c0      	bres	20672,#2
 180  0049               L16:
 181                     ; 140 }
 184  0049 81            	ret
 219                     ; 154 void CLK_HSECmd(FunctionalState CLK_NewState)
 219                     ; 155 {
 220                     	switch	.text
 221  004a               _CLK_HSECmd:
 225                     ; 158   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 227                     ; 160   if (CLK_NewState != DISABLE)
 229  004a 4d            	tnz	a
 230  004b 2706          	jreq	L101
 231                     ; 163     CLK->ECKR |= CLK_ECKR_HSEEN;
 233  004d 721050c1      	bset	20673,#0
 235  0051 2004          	jra	L301
 236  0053               L101:
 237                     ; 168     CLK->ECKR &= (u8)(~CLK_ECKR_HSEEN);
 239  0053 721150c1      	bres	20673,#0
 240  0057               L301:
 241                     ; 171 }
 244  0057 81            	ret
 279                     ; 185 void CLK_HSICmd(FunctionalState CLK_NewState)
 279                     ; 186 {
 280                     	switch	.text
 281  0058               _CLK_HSICmd:
 285                     ; 189   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 287                     ; 191   if (CLK_NewState != DISABLE)
 289  0058 4d            	tnz	a
 290  0059 2706          	jreq	L321
 291                     ; 194     CLK->ICKR |= CLK_ICKR_HSIEN;
 293  005b 721050c0      	bset	20672,#0
 295  005f 2004          	jra	L521
 296  0061               L321:
 297                     ; 199     CLK->ICKR &= (u8)(~CLK_ICKR_HSIEN);
 299  0061 721150c0      	bres	20672,#0
 300  0065               L521:
 301                     ; 202 }
 304  0065 81            	ret
 339                     ; 216 void CLK_LSICmd(FunctionalState CLK_NewState)
 339                     ; 217 {
 340                     	switch	.text
 341  0066               _CLK_LSICmd:
 345                     ; 220   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 347                     ; 222   if (CLK_NewState != DISABLE)
 349  0066 4d            	tnz	a
 350  0067 2706          	jreq	L541
 351                     ; 225     CLK->ICKR |= CLK_ICKR_LSIEN;
 353  0069 721650c0      	bset	20672,#3
 355  006d 2004          	jra	L741
 356  006f               L541:
 357                     ; 230     CLK->ICKR &= (u8)(~CLK_ICKR_LSIEN);
 359  006f 721750c0      	bres	20672,#3
 360  0073               L741:
 361                     ; 233 }
 364  0073 81            	ret
 399                     ; 248 void CLK_CCOCmd(FunctionalState CLK_NewState)
 399                     ; 249 {
 400                     	switch	.text
 401  0074               _CLK_CCOCmd:
 405                     ; 252   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 407                     ; 254   if (CLK_NewState != DISABLE)
 409  0074 4d            	tnz	a
 410  0075 2706          	jreq	L761
 411                     ; 257     CLK->CCOR |= CLK_CCOR_CCOEN;
 413  0077 721050c9      	bset	20681,#0
 415  007b 2004          	jra	L171
 416  007d               L761:
 417                     ; 262     CLK->CCOR &= (u8)(~CLK_CCOR_CCOEN);
 419  007d 721150c9      	bres	20681,#0
 420  0081               L171:
 421                     ; 265 }
 424  0081 81            	ret
 459                     ; 281 void CLK_ClockSwitchCmd(FunctionalState CLK_NewState)
 459                     ; 282 {
 460                     	switch	.text
 461  0082               _CLK_ClockSwitchCmd:
 465                     ; 285   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 467                     ; 287   if (CLK_NewState != DISABLE )
 469  0082 4d            	tnz	a
 470  0083 2706          	jreq	L112
 471                     ; 290     CLK->SWCR |= CLK_SWCR_SWEN;
 473  0085 721250c5      	bset	20677,#1
 475  0089 2004          	jra	L312
 476  008b               L112:
 477                     ; 295     CLK->SWCR &= (u8)(~CLK_SWCR_SWEN);
 479  008b 721350c5      	bres	20677,#1
 480  008f               L312:
 481                     ; 298 }
 484  008f 81            	ret
 520                     ; 315 void CLK_SlowActiveHaltWakeUpCmd(FunctionalState NewState)
 520                     ; 316 {
 521                     	switch	.text
 522  0090               _CLK_SlowActiveHaltWakeUpCmd:
 526                     ; 319   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 528                     ; 321   if (NewState != DISABLE)
 530  0090 4d            	tnz	a
 531  0091 2706          	jreq	L332
 532                     ; 324     CLK->ICKR |= CLK_ICKR_SWUAH;
 534  0093 721a50c0      	bset	20672,#5
 536  0097 2004          	jra	L532
 537  0099               L332:
 538                     ; 329     CLK->ICKR &= (u8)(~CLK_ICKR_SWUAH);
 540  0099 721b50c0      	bres	20672,#5
 541  009d               L532:
 542                     ; 332 }
 545  009d 81            	ret
 680                     ; 349 void CLK_PeripheralClockConfig(CLK_Peripheral_TypeDef CLK_Peripheral, FunctionalState CLK_NewState)
 680                     ; 350 {
 681                     	switch	.text
 682  009e               _CLK_PeripheralClockConfig:
 684  009e 89            	pushw	x
 685       00000000      OFST:	set	0
 688                     ; 353   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 690                     ; 354   assert_param(IS_CLK_PERIPHERAL_OK(CLK_Peripheral));
 692                     ; 356   if (((u8)CLK_Peripheral & (u8)0x10) == 0x00)
 694  009f 9e            	ld	a,xh
 695  00a0 a510          	bcp	a,#16
 696  00a2 2633          	jrne	L313
 697                     ; 358     if (CLK_NewState != DISABLE)
 699  00a4 0d02          	tnz	(OFST+2,sp)
 700  00a6 2717          	jreq	L513
 701                     ; 361       CLK->PCKENR1 |= (u8)((u8)1 << ((u8)CLK_Peripheral & (u8)0x0F));
 703  00a8 7b01          	ld	a,(OFST+1,sp)
 704  00aa a40f          	and	a,#15
 705  00ac 5f            	clrw	x
 706  00ad 97            	ld	xl,a
 707  00ae a601          	ld	a,#1
 708  00b0 5d            	tnzw	x
 709  00b1 2704          	jreq	L62
 710  00b3               L03:
 711  00b3 48            	sll	a
 712  00b4 5a            	decw	x
 713  00b5 26fc          	jrne	L03
 714  00b7               L62:
 715  00b7 ca50c7        	or	a,20679
 716  00ba c750c7        	ld	20679,a
 718  00bd 2049          	jra	L123
 719  00bf               L513:
 720                     ; 366       CLK->PCKENR1 &= (u8)(~(u8)(((u8)1 << ((u8)CLK_Peripheral & (u8)0x0F))));
 722  00bf 7b01          	ld	a,(OFST+1,sp)
 723  00c1 a40f          	and	a,#15
 724  00c3 5f            	clrw	x
 725  00c4 97            	ld	xl,a
 726  00c5 a601          	ld	a,#1
 727  00c7 5d            	tnzw	x
 728  00c8 2704          	jreq	L23
 729  00ca               L43:
 730  00ca 48            	sll	a
 731  00cb 5a            	decw	x
 732  00cc 26fc          	jrne	L43
 733  00ce               L23:
 734  00ce 43            	cpl	a
 735  00cf c450c7        	and	a,20679
 736  00d2 c750c7        	ld	20679,a
 737  00d5 2031          	jra	L123
 738  00d7               L313:
 739                     ; 371     if (CLK_NewState != DISABLE)
 741  00d7 0d02          	tnz	(OFST+2,sp)
 742  00d9 2717          	jreq	L323
 743                     ; 374       CLK->PCKENR2 |= (u8)((u8)1 << ((u8)CLK_Peripheral & (u8)0x0F));
 745  00db 7b01          	ld	a,(OFST+1,sp)
 746  00dd a40f          	and	a,#15
 747  00df 5f            	clrw	x
 748  00e0 97            	ld	xl,a
 749  00e1 a601          	ld	a,#1
 750  00e3 5d            	tnzw	x
 751  00e4 2704          	jreq	L63
 752  00e6               L04:
 753  00e6 48            	sll	a
 754  00e7 5a            	decw	x
 755  00e8 26fc          	jrne	L04
 756  00ea               L63:
 757  00ea ca50ca        	or	a,20682
 758  00ed c750ca        	ld	20682,a
 760  00f0 2016          	jra	L123
 761  00f2               L323:
 762                     ; 379       CLK->PCKENR2 &= (u8)(~(u8)(((u8)1 << ((u8)CLK_Peripheral & (u8)0x0F))));
 764  00f2 7b01          	ld	a,(OFST+1,sp)
 765  00f4 a40f          	and	a,#15
 766  00f6 5f            	clrw	x
 767  00f7 97            	ld	xl,a
 768  00f8 a601          	ld	a,#1
 769  00fa 5d            	tnzw	x
 770  00fb 2704          	jreq	L24
 771  00fd               L44:
 772  00fd 48            	sll	a
 773  00fe 5a            	decw	x
 774  00ff 26fc          	jrne	L44
 775  0101               L24:
 776  0101 43            	cpl	a
 777  0102 c450ca        	and	a,20682
 778  0105 c750ca        	ld	20682,a
 779  0108               L123:
 780                     ; 383 }
 783  0108 85            	popw	x
 784  0109 81            	ret
 970                     ; 405 ErrorStatus CLK_ClockSwitchConfig(CLK_SwitchMode_TypeDef CLK_SwitchMode, CLK_Source_TypeDef CLK_NewClock, FunctionalState CLK_SwitchIT, CLK_CurrentClockState_TypeDef CLK_CurrentClockState)
 970                     ; 406 {
 971                     	switch	.text
 972  010a               _CLK_ClockSwitchConfig:
 974  010a 89            	pushw	x
 975  010b 5204          	subw	sp,#4
 976       00000004      OFST:	set	4
 979                     ; 409   u16 DownCounter = CLK_TIMEOUT;
 981  010d ae0491        	ldw	x,#1169
 982  0110 1f03          	ldw	(OFST-1,sp),x
 983                     ; 410   ErrorStatus Swif = ERROR;
 985  0112 7b02          	ld	a,(OFST-2,sp)
 986  0114 97            	ld	xl,a
 987                     ; 413   assert_param(IS_CLK_SOURCE_OK(CLK_NewClock));
 989                     ; 414   assert_param(IS_CLK_SWITCHMODE_OK(CLK_SwitchMode));
 991                     ; 415   assert_param(IS_FUNCTIONALSTATE_OK(CLK_SwitchIT));
 993                     ; 416   assert_param(IS_CLK_CURRENTCLOCKSTATE_OK(CLK_CurrentClockState));
 995                     ; 419   clock_master = (CLK_Source_TypeDef)CLK->CMSR;
 997  0115 c650c3        	ld	a,20675
 998  0118 6b01          	ld	(OFST-3,sp),a
 999                     ; 422   if (CLK_SwitchMode == CLK_SWITCHMODE_AUTO)
1001  011a 7b05          	ld	a,(OFST+1,sp)
1002  011c a101          	cp	a,#1
1003  011e 2639          	jrne	L534
1004                     ; 426     CLK->SWCR |= CLK_SWCR_SWEN;
1006  0120 721250c5      	bset	20677,#1
1007                     ; 429     if (CLK_SwitchIT != DISABLE)
1009  0124 0d09          	tnz	(OFST+5,sp)
1010  0126 2706          	jreq	L734
1011                     ; 431       CLK->SWCR |= CLK_SWCR_SWIEN;
1013  0128 721450c5      	bset	20677,#2
1015  012c 2004          	jra	L144
1016  012e               L734:
1017                     ; 435       CLK->SWCR &= (u8)(~CLK_SWCR_SWIEN);
1019  012e 721550c5      	bres	20677,#2
1020  0132               L144:
1021                     ; 439     CLK->SWR = (u8)CLK_NewClock;
1023  0132 7b06          	ld	a,(OFST+2,sp)
1024  0134 c750c4        	ld	20676,a
1026  0137 2007          	jra	L744
1027  0139               L344:
1028                     ; 443       DownCounter--;
1030  0139 1e03          	ldw	x,(OFST-1,sp)
1031  013b 1d0001        	subw	x,#1
1032  013e 1f03          	ldw	(OFST-1,sp),x
1033  0140               L744:
1034                     ; 441     while (((CLK->SWCR & CLK_SWCR_SWBSY) && (DownCounter != 0)))
1036  0140 c650c5        	ld	a,20677
1037  0143 a501          	bcp	a,#1
1038  0145 2704          	jreq	L354
1040  0147 1e03          	ldw	x,(OFST-1,sp)
1041  0149 26ee          	jrne	L344
1042  014b               L354:
1043                     ; 446     if (DownCounter != 0)
1045  014b 1e03          	ldw	x,(OFST-1,sp)
1046  014d 2706          	jreq	L554
1047                     ; 448       Swif = SUCCESS;
1049  014f a601          	ld	a,#1
1050  0151 6b02          	ld	(OFST-2,sp),a
1052  0153 201b          	jra	L164
1053  0155               L554:
1054                     ; 452       Swif = ERROR;
1056  0155 0f02          	clr	(OFST-2,sp)
1057  0157 2017          	jra	L164
1058  0159               L534:
1059                     ; 460     if (CLK_SwitchIT != DISABLE)
1061  0159 0d09          	tnz	(OFST+5,sp)
1062  015b 2706          	jreq	L364
1063                     ; 462       CLK->SWCR |= CLK_SWCR_SWIEN;
1065  015d 721450c5      	bset	20677,#2
1067  0161 2004          	jra	L564
1068  0163               L364:
1069                     ; 466       CLK->SWCR &= (u8)(~CLK_SWCR_SWIEN);
1071  0163 721550c5      	bres	20677,#2
1072  0167               L564:
1073                     ; 470     CLK->SWR = (u8)CLK_NewClock;
1075  0167 7b06          	ld	a,(OFST+2,sp)
1076  0169 c750c4        	ld	20676,a
1077                     ; 474     Swif = SUCCESS;
1079  016c a601          	ld	a,#1
1080  016e 6b02          	ld	(OFST-2,sp),a
1081  0170               L164:
1082                     ; 479   if ((CLK_CurrentClockState == CLK_CURRENTCLOCKSTATE_DISABLE) && ( clock_master == CLK_SOURCE_HSI))
1084  0170 0d0a          	tnz	(OFST+6,sp)
1085  0172 260c          	jrne	L764
1087  0174 7b01          	ld	a,(OFST-3,sp)
1088  0176 a1e1          	cp	a,#225
1089  0178 2606          	jrne	L764
1090                     ; 481     CLK->ICKR &= (u8)(~CLK_ICKR_HSIEN);
1092  017a 721150c0      	bres	20672,#0
1094  017e 201e          	jra	L174
1095  0180               L764:
1096                     ; 483   else if ((CLK_CurrentClockState == CLK_CURRENTCLOCKSTATE_DISABLE) && ( clock_master == CLK_SOURCE_LSI))
1098  0180 0d0a          	tnz	(OFST+6,sp)
1099  0182 260c          	jrne	L374
1101  0184 7b01          	ld	a,(OFST-3,sp)
1102  0186 a1d2          	cp	a,#210
1103  0188 2606          	jrne	L374
1104                     ; 485     CLK->ICKR &= (u8)(~CLK_ICKR_LSIEN);
1106  018a 721750c0      	bres	20672,#3
1108  018e 200e          	jra	L174
1109  0190               L374:
1110                     ; 487   else if ((CLK_CurrentClockState == CLK_CURRENTCLOCKSTATE_DISABLE) && ( clock_master == CLK_SOURCE_HSE))
1112  0190 0d0a          	tnz	(OFST+6,sp)
1113  0192 260a          	jrne	L174
1115  0194 7b01          	ld	a,(OFST-3,sp)
1116  0196 a1b4          	cp	a,#180
1117  0198 2604          	jrne	L174
1118                     ; 489     CLK->ECKR &= (u8)(~CLK_ECKR_HSEEN);
1120  019a 721150c1      	bres	20673,#0
1121  019e               L174:
1122                     ; 492   return(Swif);
1124  019e 7b02          	ld	a,(OFST-2,sp)
1127  01a0 5b06          	addw	sp,#6
1128  01a2 81            	ret
1266                     ; 509 void CLK_HSIPrescalerConfig(CLK_Prescaler_TypeDef HSIPrescaler)
1266                     ; 510 {
1267                     	switch	.text
1268  01a3               _CLK_HSIPrescalerConfig:
1270  01a3 88            	push	a
1271       00000000      OFST:	set	0
1274                     ; 513   assert_param(IS_CLK_HSIPRESCALER_OK(HSIPrescaler));
1276                     ; 516   CLK->CKDIVR &= (u8)(~CLK_CKDIVR_HSIDIV);
1278  01a4 c650c6        	ld	a,20678
1279  01a7 a4e7          	and	a,#231
1280  01a9 c750c6        	ld	20678,a
1281                     ; 519   CLK->CKDIVR |= (u8)HSIPrescaler;
1283  01ac c650c6        	ld	a,20678
1284  01af 1a01          	or	a,(OFST+1,sp)
1285  01b1 c750c6        	ld	20678,a
1286                     ; 521 }
1289  01b4 84            	pop	a
1290  01b5 81            	ret
1425                     ; 539 void CLK_CCOConfig(CLK_Output_TypeDef CLK_CCO)
1425                     ; 540 {
1426                     	switch	.text
1427  01b6               _CLK_CCOConfig:
1429  01b6 88            	push	a
1430       00000000      OFST:	set	0
1433                     ; 543   assert_param(IS_CLK_OUTPUT_OK(CLK_CCO));
1435                     ; 546   CLK->CCOR &= (u8)(~CLK_CCOR_CCOSEL);
1437  01b7 c650c9        	ld	a,20681
1438  01ba a4e1          	and	a,#225
1439  01bc c750c9        	ld	20681,a
1440                     ; 549   CLK->CCOR |= (u8)CLK_CCO;
1442  01bf c650c9        	ld	a,20681
1443  01c2 1a01          	or	a,(OFST+1,sp)
1444  01c4 c750c9        	ld	20681,a
1445                     ; 552   CLK->CCOR |= CLK_CCOR_CCOEN;
1447  01c7 721050c9      	bset	20681,#0
1448                     ; 554 }
1451  01cb 84            	pop	a
1452  01cc 81            	ret
1517                     ; 571 void CLK_ITConfig(CLK_IT_TypeDef CLK_IT, FunctionalState IT_NewState)
1517                     ; 572 {
1518                     	switch	.text
1519  01cd               _CLK_ITConfig:
1521  01cd 89            	pushw	x
1522       00000000      OFST:	set	0
1525                     ; 575   assert_param(IS_FUNCTIONALSTATE_OK(IT_NewState));
1527                     ; 576   assert_param(IS_CLK_IT_OK(CLK_IT));
1529                     ; 578   if (IT_NewState != DISABLE)
1531  01ce 9f            	ld	a,xl
1532  01cf 4d            	tnz	a
1533  01d0 2719          	jreq	L576
1534                     ; 580     switch (CLK_IT)
1536  01d2 9e            	ld	a,xh
1538                     ; 588       default:
1538                     ; 589         break;
1539  01d3 a00c          	sub	a,#12
1540  01d5 270a          	jreq	L136
1541  01d7 a010          	sub	a,#16
1542  01d9 2624          	jrne	L307
1543                     ; 582       case CLK_IT_SWIF: /* Enable the clock switch interrupt */
1543                     ; 583         CLK->SWCR |= CLK_SWCR_SWIEN;
1545  01db 721450c5      	bset	20677,#2
1546                     ; 584         break;
1548  01df 201e          	jra	L307
1549  01e1               L136:
1550                     ; 585       case CLK_IT_CSSD: /* Enable the clock security system detection interrupt */
1550                     ; 586         CLK->CSSR |= CLK_CSSR_CSSDIE;
1552  01e1 721450c8      	bset	20680,#2
1553                     ; 587         break;
1555  01e5 2018          	jra	L307
1556  01e7               L336:
1557                     ; 588       default:
1557                     ; 589         break;
1559  01e7 2016          	jra	L307
1560  01e9               L107:
1562  01e9 2014          	jra	L307
1563  01eb               L576:
1564                     ; 594     switch (CLK_IT)
1566  01eb 7b01          	ld	a,(OFST+1,sp)
1568                     ; 602       default:
1568                     ; 603         break;
1569  01ed a00c          	sub	a,#12
1570  01ef 270a          	jreq	L736
1571  01f1 a010          	sub	a,#16
1572  01f3 260a          	jrne	L307
1573                     ; 596       case CLK_IT_SWIF: /* Disable the clock switch interrupt */
1573                     ; 597         CLK->SWCR  &= (u8)(~CLK_SWCR_SWIEN);
1575  01f5 721550c5      	bres	20677,#2
1576                     ; 598         break;
1578  01f9 2004          	jra	L307
1579  01fb               L736:
1580                     ; 599       case CLK_IT_CSSD: /* Disable the clock security system detection interrupt */
1580                     ; 600         CLK->CSSR &= (u8)(~CLK_CSSR_CSSDIE);
1582  01fb 721550c8      	bres	20680,#2
1583                     ; 601         break;
1584  01ff               L307:
1585                     ; 607 }
1588  01ff 85            	popw	x
1589  0200 81            	ret
1590  0201               L146:
1591                     ; 602       default:
1591                     ; 603         break;
1593  0201 20fc          	jra	L307
1594  0203               L707:
1595  0203 20fa          	jra	L307
1630                     ; 623 void CLK_SYSCLKConfig(CLK_Prescaler_TypeDef ClockPrescaler)
1630                     ; 624 {
1631                     	switch	.text
1632  0205               _CLK_SYSCLKConfig:
1634  0205 88            	push	a
1635       00000000      OFST:	set	0
1638                     ; 627   assert_param(IS_CLK_PRESCALER_OK(ClockPrescaler));
1640                     ; 629   if (((u8)ClockPrescaler & (u8)0x80) == 0x00) /* Bit7 = 0 means HSI divider */
1642  0206 a580          	bcp	a,#128
1643  0208 2614          	jrne	L727
1644                     ; 631     CLK->CKDIVR &= (u8)(~CLK_CKDIVR_HSIDIV);
1646  020a c650c6        	ld	a,20678
1647  020d a4e7          	and	a,#231
1648  020f c750c6        	ld	20678,a
1649                     ; 632     CLK->CKDIVR |= (u8)((u8)ClockPrescaler & (u8)CLK_CKDIVR_HSIDIV);
1651  0212 7b01          	ld	a,(OFST+1,sp)
1652  0214 a418          	and	a,#24
1653  0216 ca50c6        	or	a,20678
1654  0219 c750c6        	ld	20678,a
1656  021c 2012          	jra	L137
1657  021e               L727:
1658                     ; 636     CLK->CKDIVR &= (u8)(~CLK_CKDIVR_CPUDIV);
1660  021e c650c6        	ld	a,20678
1661  0221 a4f8          	and	a,#248
1662  0223 c750c6        	ld	20678,a
1663                     ; 637     CLK->CKDIVR |= (u8)((u8)ClockPrescaler & (u8)CLK_CKDIVR_CPUDIV);
1665  0226 7b01          	ld	a,(OFST+1,sp)
1666  0228 a407          	and	a,#7
1667  022a ca50c6        	or	a,20678
1668  022d c750c6        	ld	20678,a
1669  0230               L137:
1670                     ; 640 }
1673  0230 84            	pop	a
1674  0231 81            	ret
1730                     ; 654 void CLK_SWIMConfig(CLK_SWIMDivider_TypeDef CLK_SWIMDivider)
1730                     ; 655 {
1731                     	switch	.text
1732  0232               _CLK_SWIMConfig:
1736                     ; 658   assert_param(IS_CLK_SWIMDIVIDER_OK(CLK_SWIMDivider));
1738                     ; 660   if (CLK_SWIMDivider != CLK_SWIMDIVIDER_2)
1740  0232 4d            	tnz	a
1741  0233 2706          	jreq	L167
1742                     ; 663     CLK->SWIMCCR |= CLK_SWIMCCR_SWIMDIV;
1744  0235 721050cd      	bset	20685,#0
1746  0239 2004          	jra	L367
1747  023b               L167:
1748                     ; 668     CLK->SWIMCCR &= (u8)(~CLK_SWIMCCR_SWIMDIV);
1750  023b 721150cd      	bres	20685,#0
1751  023f               L367:
1752                     ; 671 }
1755  023f 81            	ret
1852                     ; 686 void CLK_CANConfig(CLK_CANDivider_TypeDef CLK_CANDivider)
1852                     ; 687 {
1853                     	switch	.text
1854  0240               _CLK_CANConfig:
1856  0240 88            	push	a
1857       00000000      OFST:	set	0
1860                     ; 690   assert_param(IS_CLK_CANDIVIDER_OK(CLK_CANDivider));
1862                     ; 693   CLK->CANCCR &= (u8)(~CLK_CANCCR_CANDIV);
1864  0241 c650cb        	ld	a,20683
1865  0244 a4f8          	and	a,#248
1866  0246 c750cb        	ld	20683,a
1867                     ; 696   CLK->CANCCR |= (u8)CLK_CANDivider;
1869  0249 c650cb        	ld	a,20683
1870  024c 1a01          	or	a,(OFST+1,sp)
1871  024e c750cb        	ld	20683,a
1872                     ; 698 }
1875  0251 84            	pop	a
1876  0252 81            	ret
1900                     ; 715 void CLK_ClockSecuritySystemEnable(void)
1900                     ; 716 {
1901                     	switch	.text
1902  0253               _CLK_ClockSecuritySystemEnable:
1906                     ; 718   CLK->CSSR |= CLK_CSSR_CSSEN;
1908  0253 721050c8      	bset	20680,#0
1909                     ; 719 }
1912  0257 81            	ret
1937                     ; 736 CLK_Source_TypeDef CLK_GetSYSCLKSource(void)
1937                     ; 737 {
1938                     	switch	.text
1939  0258               _CLK_GetSYSCLKSource:
1943                     ; 738   return((CLK_Source_TypeDef)CLK->CMSR);
1945  0258 c650c3        	ld	a,20675
1948  025b 81            	ret
2005                     ; 756 u32 CLK_GetClockFreq(void)
2005                     ; 757 {
2006                     	switch	.text
2007  025c               _CLK_GetClockFreq:
2009  025c 5209          	subw	sp,#9
2010       00000009      OFST:	set	9
2013                     ; 759   u32 clockfrequency = 0;
2015  025e 96            	ldw	x,sp
2016  025f 1c0005        	addw	x,#OFST-4
2017  0262 cd0000        	call	c_ltor
2019                     ; 760   CLK_Source_TypeDef clocksource = CLK_SOURCE_HSI;
2021  0265 7b09          	ld	a,(OFST+0,sp)
2022  0267 97            	ld	xl,a
2023                     ; 761   u8 tmp = 0, presc = 0;
2025  0268 7b09          	ld	a,(OFST+0,sp)
2026  026a 97            	ld	xl,a
2029  026b 7b09          	ld	a,(OFST+0,sp)
2030  026d 97            	ld	xl,a
2031                     ; 764   clocksource = (CLK_Source_TypeDef)CLK->CMSR;
2033  026e c650c3        	ld	a,20675
2034  0271 6b09          	ld	(OFST+0,sp),a
2035                     ; 766   if (clocksource == CLK_SOURCE_HSI)
2037  0273 7b09          	ld	a,(OFST+0,sp)
2038  0275 a1e1          	cp	a,#225
2039  0277 2642          	jrne	L3701
2040                     ; 768     tmp = (u8)(CLK->CKDIVR & CLK_CKDIVR_HSIDIV);
2042  0279 c650c6        	ld	a,20678
2043  027c a418          	and	a,#24
2044  027e 6b09          	ld	(OFST+0,sp),a
2045                     ; 769     tmp = (u8)(tmp >> 3);
2047  0280 7b09          	ld	a,(OFST+0,sp)
2048  0282 44            	srl	a
2049  0283 44            	srl	a
2050  0284 44            	srl	a
2051  0285 6b09          	ld	(OFST+0,sp),a
2052                     ; 770     presc = HSIDivFactor[tmp];
2054  0287 7b09          	ld	a,(OFST+0,sp)
2055  0289 5f            	clrw	x
2056  028a 97            	ld	xl,a
2057  028b d60000        	ld	a,(_HSIDivFactor,x)
2058  028e 6b09          	ld	(OFST+0,sp),a
2059                     ; 771     clockfrequency = HSI_VALUE / presc;
2061  0290 7b09          	ld	a,(OFST+0,sp)
2062  0292 b703          	ld	c_lreg+3,a
2063  0294 3f02          	clr	c_lreg+2
2064  0296 3f01          	clr	c_lreg+1
2065  0298 3f00          	clr	c_lreg
2066  029a 96            	ldw	x,sp
2067  029b 1c0001        	addw	x,#OFST-8
2068  029e cd0000        	call	c_rtol
2070  02a1 ae2400        	ldw	x,#9216
2071  02a4 bf02          	ldw	c_lreg+2,x
2072  02a6 ae00f4        	ldw	x,#244
2073  02a9 bf00          	ldw	c_lreg,x
2074  02ab 96            	ldw	x,sp
2075  02ac 1c0001        	addw	x,#OFST-8
2076  02af cd0000        	call	c_ludv
2078  02b2 96            	ldw	x,sp
2079  02b3 1c0005        	addw	x,#OFST-4
2080  02b6 cd0000        	call	c_rtol
2083  02b9 201c          	jra	L5701
2084  02bb               L3701:
2085                     ; 773   else if ( clocksource == CLK_SOURCE_LSI)
2087  02bb 7b09          	ld	a,(OFST+0,sp)
2088  02bd a1d2          	cp	a,#210
2089  02bf 260c          	jrne	L7701
2090                     ; 775     clockfrequency = LSI_VALUE;
2092  02c1 aef400        	ldw	x,#62464
2093  02c4 1f07          	ldw	(OFST-2,sp),x
2094  02c6 ae0001        	ldw	x,#1
2095  02c9 1f05          	ldw	(OFST-4,sp),x
2097  02cb 200a          	jra	L5701
2098  02cd               L7701:
2099                     ; 779     clockfrequency = HSE_VALUE;
2101  02cd ae3600        	ldw	x,#13824
2102  02d0 1f07          	ldw	(OFST-2,sp),x
2103  02d2 ae016e        	ldw	x,#366
2104  02d5 1f05          	ldw	(OFST-4,sp),x
2105  02d7               L5701:
2106                     ; 782   return((u32)clockfrequency);
2108  02d7 96            	ldw	x,sp
2109  02d8 1c0005        	addw	x,#OFST-4
2110  02db cd0000        	call	c_ltor
2114  02de 5b09          	addw	sp,#9
2115  02e0 81            	ret
2214                     ; 800 void CLK_AdjustHSICalibrationValue(CLK_HSITrimValue_TypeDef CLK_HSICalibrationValue)
2214                     ; 801 {
2215                     	switch	.text
2216  02e1               _CLK_AdjustHSICalibrationValue:
2218  02e1 88            	push	a
2219       00000000      OFST:	set	0
2222                     ; 804   assert_param(IS_CLK_HSITRIMVALUE_OK(CLK_HSICalibrationValue));
2224                     ; 807   CLK->HSITRIMR = (u8)((CLK->HSITRIMR & (u8)(~CLK_HSITRIMR_HSITRIM))|((u8)CLK_HSICalibrationValue));
2226  02e2 c650cc        	ld	a,20684
2227  02e5 a4f8          	and	a,#248
2228  02e7 1a01          	or	a,(OFST+1,sp)
2229  02e9 c750cc        	ld	20684,a
2230                     ; 809 }
2233  02ec 84            	pop	a
2234  02ed 81            	ret
2258                     ; 828 void CLK_SYSCLKEmergencyClear(void)
2258                     ; 829 {
2259                     	switch	.text
2260  02ee               _CLK_SYSCLKEmergencyClear:
2264                     ; 830   CLK->SWCR &= (u8)(~CLK_SWCR_SWBSY);
2266  02ee 721150c5      	bres	20677,#0
2267                     ; 831 }
2270  02f2 81            	ret
2419                     ; 847 FlagStatus CLK_GetFlagStatus(CLK_Flag_TypeDef CLK_FLAG)
2419                     ; 848 {
2420                     	switch	.text
2421  02f3               _CLK_GetFlagStatus:
2423  02f3 89            	pushw	x
2424  02f4 5203          	subw	sp,#3
2425       00000003      OFST:	set	3
2428                     ; 850   u16 statusreg = 0;
2430  02f6 1e01          	ldw	x,(OFST-2,sp)
2431                     ; 851   u8 tmpreg = 0;
2433  02f8 7b03          	ld	a,(OFST+0,sp)
2434  02fa 97            	ld	xl,a
2435                     ; 852   FlagStatus bitstatus = RESET;
2437  02fb 7b03          	ld	a,(OFST+0,sp)
2438  02fd 97            	ld	xl,a
2439                     ; 855   assert_param(IS_CLK_FLAG_OK(CLK_FLAG));
2441                     ; 858   statusreg = (u16)((u16)CLK_FLAG & (u16)0xFF00);
2443  02fe 7b04          	ld	a,(OFST+1,sp)
2444  0300 97            	ld	xl,a
2445  0301 7b05          	ld	a,(OFST+2,sp)
2446  0303 9f            	ld	a,xl
2447  0304 a4ff          	and	a,#255
2448  0306 97            	ld	xl,a
2449  0307 4f            	clr	a
2450  0308 02            	rlwa	x,a
2451  0309 1f01          	ldw	(OFST-2,sp),x
2452  030b 01            	rrwa	x,a
2453                     ; 861   if (statusreg == 0x0100) /* The flag to check is in ICKRregister */
2455  030c 1e01          	ldw	x,(OFST-2,sp)
2456  030e a30100        	cpw	x,#256
2457  0311 2607          	jrne	L1421
2458                     ; 863     tmpreg = CLK->ICKR;
2460  0313 c650c0        	ld	a,20672
2461  0316 6b03          	ld	(OFST+0,sp),a
2463  0318 202f          	jra	L3421
2464  031a               L1421:
2465                     ; 865   else if (statusreg == 0x0200) /* The flag to check is in ECKRregister */
2467  031a 1e01          	ldw	x,(OFST-2,sp)
2468  031c a30200        	cpw	x,#512
2469  031f 2607          	jrne	L5421
2470                     ; 867     tmpreg = CLK->ECKR;
2472  0321 c650c1        	ld	a,20673
2473  0324 6b03          	ld	(OFST+0,sp),a
2475  0326 2021          	jra	L3421
2476  0328               L5421:
2477                     ; 869   else if (statusreg == 0x0300) /* The flag to check is in SWIC register */
2479  0328 1e01          	ldw	x,(OFST-2,sp)
2480  032a a30300        	cpw	x,#768
2481  032d 2607          	jrne	L1521
2482                     ; 871     tmpreg = CLK->SWCR;
2484  032f c650c5        	ld	a,20677
2485  0332 6b03          	ld	(OFST+0,sp),a
2487  0334 2013          	jra	L3421
2488  0336               L1521:
2489                     ; 873   else if (statusreg == 0x0400) /* The flag to check is in CSS register */
2491  0336 1e01          	ldw	x,(OFST-2,sp)
2492  0338 a30400        	cpw	x,#1024
2493  033b 2607          	jrne	L5521
2494                     ; 875     tmpreg = CLK->CSSR;
2496  033d c650c8        	ld	a,20680
2497  0340 6b03          	ld	(OFST+0,sp),a
2499  0342 2005          	jra	L3421
2500  0344               L5521:
2501                     ; 879     tmpreg = CLK->CCOR;
2503  0344 c650c9        	ld	a,20681
2504  0347 6b03          	ld	(OFST+0,sp),a
2505  0349               L3421:
2506                     ; 882   if ((tmpreg & (u8)CLK_FLAG) != (u8)RESET)
2508  0349 7b05          	ld	a,(OFST+2,sp)
2509  034b 1503          	bcp	a,(OFST+0,sp)
2510  034d 2706          	jreq	L1621
2511                     ; 884     bitstatus = SET;
2513  034f a601          	ld	a,#1
2514  0351 6b03          	ld	(OFST+0,sp),a
2516  0353 2002          	jra	L3621
2517  0355               L1621:
2518                     ; 888     bitstatus = RESET;
2520  0355 0f03          	clr	(OFST+0,sp)
2521  0357               L3621:
2522                     ; 892   return((FlagStatus)bitstatus);
2524  0357 7b03          	ld	a,(OFST+0,sp)
2527  0359 5b05          	addw	sp,#5
2528  035b 81            	ret
2574                     ; 913 ITStatus CLK_GetITStatus(CLK_IT_TypeDef CLK_IT)
2574                     ; 914 {
2575                     	switch	.text
2576  035c               _CLK_GetITStatus:
2578  035c 88            	push	a
2579  035d 88            	push	a
2580       00000001      OFST:	set	1
2583                     ; 916   ITStatus bitstatus = RESET;
2585  035e 0f01          	clr	(OFST+0,sp)
2586                     ; 919   assert_param(IS_CLK_IT_OK(CLK_IT));
2588                     ; 921   if (CLK_IT == CLK_IT_SWIF)
2590  0360 a11c          	cp	a,#28
2591  0362 2611          	jrne	L7031
2592                     ; 924     if ((CLK->SWCR & (u8)CLK_IT) == (u8)0x0C)
2594  0364 c450c5        	and	a,20677
2595  0367 a10c          	cp	a,#12
2596  0369 2606          	jrne	L1131
2597                     ; 926       bitstatus = SET;
2599  036b a601          	ld	a,#1
2600  036d 6b01          	ld	(OFST+0,sp),a
2602  036f 2015          	jra	L5131
2603  0371               L1131:
2604                     ; 930       bitstatus = RESET;
2606  0371 0f01          	clr	(OFST+0,sp)
2607  0373 2011          	jra	L5131
2608  0375               L7031:
2609                     ; 936     if ((CLK->CSSR & (u8)CLK_IT) == (u8)0x0C)
2611  0375 c650c8        	ld	a,20680
2612  0378 1402          	and	a,(OFST+1,sp)
2613  037a a10c          	cp	a,#12
2614  037c 2606          	jrne	L7131
2615                     ; 938       bitstatus = SET;
2617  037e a601          	ld	a,#1
2618  0380 6b01          	ld	(OFST+0,sp),a
2620  0382 2002          	jra	L5131
2621  0384               L7131:
2622                     ; 942       bitstatus = RESET;
2624  0384 0f01          	clr	(OFST+0,sp)
2625  0386               L5131:
2626                     ; 947   return bitstatus;
2628  0386 7b01          	ld	a,(OFST+0,sp)
2631  0388 85            	popw	x
2632  0389 81            	ret
2668                     ; 966 void CLK_ClearITPendingBit(CLK_IT_TypeDef CLK_IT)
2668                     ; 967 {
2669                     	switch	.text
2670  038a               _CLK_ClearITPendingBit:
2674                     ; 970   assert_param(IS_CLK_IT_OK(CLK_IT));
2676                     ; 972   if (CLK_IT == (u8)CLK_IT_CSSD)
2678  038a a10c          	cp	a,#12
2679  038c 2606          	jrne	L1431
2680                     ; 975     CLK->CSSR &= (u8)(~CLK_CSSR_CSSD);
2682  038e 721750c8      	bres	20680,#3
2684  0392 2004          	jra	L3431
2685  0394               L1431:
2686                     ; 980     CLK->SWCR &= (u8)(~CLK_SWCR_SWIF);
2688  0394 721750c5      	bres	20677,#3
2689  0398               L3431:
2690                     ; 983 }
2693  0398 81            	ret
2728                     	xdef	_CLKPrescTable
2729                     	xdef	_HSIDivFactor
2730                     	xdef	_CLK_ClearITPendingBit
2731                     	xdef	_CLK_GetITStatus
2732                     	xdef	_CLK_GetFlagStatus
2733                     	xdef	_CLK_GetSYSCLKSource
2734                     	xdef	_CLK_GetClockFreq
2735                     	xdef	_CLK_AdjustHSICalibrationValue
2736                     	xdef	_CLK_SYSCLKEmergencyClear
2737                     	xdef	_CLK_ClockSecuritySystemEnable
2738                     	xdef	_CLK_CANConfig
2739                     	xdef	_CLK_SWIMConfig
2740                     	xdef	_CLK_SYSCLKConfig
2741                     	xdef	_CLK_ITConfig
2742                     	xdef	_CLK_CCOConfig
2743                     	xdef	_CLK_HSIPrescalerConfig
2744                     	xdef	_CLK_ClockSwitchConfig
2745                     	xdef	_CLK_PeripheralClockConfig
2746                     	xdef	_CLK_SlowActiveHaltWakeUpCmd
2747                     	xdef	_CLK_FastHaltWakeUpCmd
2748                     	xdef	_CLK_ClockSwitchCmd
2749                     	xdef	_CLK_CCOCmd
2750                     	xdef	_CLK_LSICmd
2751                     	xdef	_CLK_HSICmd
2752                     	xdef	_CLK_HSECmd
2753                     	xdef	_CLK_DeInit
2754                     	xref.b	c_lreg
2773                     	xref	c_ludv
2774                     	xref	c_rtol
2775                     	xref	c_ltor
2776                     	end
